package example.android.menudialogmondai;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.DatePicker;

public class MenuDialogMondaiActivity extends Activity {
	// vt@Xt@C
    private static final String FILE_NAME = "MenuDialogFile";   	
	
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.menudialogmondai);        
    }
    
    // onCreateOptionsMenu\bh(IvVj[)
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        
        // j[ACe1̒ǉ
        MenuItem item1=menu.add(0,0,0,"ݒ");
        item1.setIcon(android.R.drawable.ic_menu_add);
        
        // j[ACe2̒ǉ
        MenuItem item2=menu.add(0,1,0,"\");
        item2.setIcon(android.R.drawable.ic_menu_info_details);

        return true;
    }    

    // onOptionsItemSelected\bh(j[ACeI)
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case 0:
            	showDatePickerDialog();
                return true;
            case 1:
            	// vt@XIuWFNg擾
                SharedPreferences preference = getSharedPreferences(FILE_NAME, MODE_PRIVATE);
     
                // ۑf[^擾
                String date = preference.getString("DATE", "܂");

                showDialog(date);
                return true;          
        }
        return true;
    }    
    
    // tI_CAO̕\
    public void showDatePickerDialog() {
        Calendar cal = Calendar.getInstance();
        
        DatePickerDialog dialog = new DatePickerDialog(MenuDialogMondaiActivity.this
                ,new DatePickerDialog.OnDateSetListener() { 
                    @Override
                    public void onDateSet(DatePicker picker, int year, int month, int day) {
                    	// vt@XIuWFNg擾
                        SharedPreferences preference = getSharedPreferences(FILE_NAME, MODE_PRIVATE);
             
                        // vt@X̕ҏWpIuWFNg擾
                        SharedPreferences.Editor editor = preference.edit();   
                        
                        // 擾vt@Xt@Cɕۑ
                        editor.putString("DATE",year + "N" + (month + 1) + "" + day + "");  
                        editor.commit();
                    }
                }
                ,cal.get(Calendar.YEAR)
                ,cal.get(Calendar.MONTH)
                ,cal.get(Calendar.DAY_OF_MONTH)
        );
        dialog.show(); 
    }
    
    // showDialog\bh(_CAO\)
    private void showDialog(String text) {
        AlertDialog.Builder dialog=new AlertDialog.Builder(MenuDialogMondaiActivity.this);
        dialog.setTitle("ۑ");
        dialog.setMessage(text);
        dialog.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
            	MenuDialogMondaiActivity.this.setResult(Activity.RESULT_OK);
            }
        });
        dialog.create();
        dialog.show();
    }
}