package example.android.contentprovidersample1;

import android.app.Activity;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class ContentProviderSample1Activity extends Activity {
	CreateProductHelper helper = null;
    SQLiteDatabase db = null;	
	
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.contentprovidersample1);
        
        // o^{^̃NbNXi[ݒ
        Button insertBtn = (Button)findViewById(R.id.insert);
        insertBtn.setTag("insert");
        insertBtn.setOnClickListener(new ButtonClickListener());
        // XV{^̃NbNXi[ݒ
        Button updatetBtn = (Button)findViewById(R.id.update);
        updatetBtn.setTag("update");
        updatetBtn.setOnClickListener(new ButtonClickListener());
        // 폜{^̃NbNXi[ݒ
        Button delBtn = (Button)findViewById(R.id.delete);
        delBtn.setTag("delete");
        delBtn.setOnClickListener(new ButtonClickListener());
        // \{^̃NbNXi[ݒ
        Button selectBtn = (Button)findViewById(R.id.select); 
        selectBtn.setTag("select");
        selectBtn.setOnClickListener(new ButtonClickListener());
        
        // DB쐬
        helper = new CreateProductHelper(ContentProviderSample1Activity.this);
    }
    
    // NbNXi[`
    class ButtonClickListener implements OnClickListener {
    	// onClick\bh({^NbNCxgnh)
    	public void onClick(View v){
    		// ^O̎擾
    		String tag = (String)v.getTag();
    		
    		// bZ[W\p
            String message  = "";
            TextView label = (TextView)findViewById(R.id.message);
            
            // ͏擾
			EditText productid = (EditText)findViewById(R.id.id);
            EditText name = (EditText)findViewById(R.id.name);
            EditText price = (EditText)findViewById(R.id.price);
            
            // e[uCAEgIuWFNg擾
            TableLayout tablelayout = (TableLayout)findViewById(R.id.list);

            // e[uCAEg̃NA
            tablelayout.removeAllViews();
            
            // YDBIuWFNg擾
            db = helper.getWritableDatabase();
    		
    		// o^{^ꂽꍇ
    		if(tag.equals("insert")){
                
                // e[u쐬
                try{
                    
                	// SQL`
                    String sql 
                         = "create table product(_id integer primary key autoincrement," +
                           "productid text not null," +
                           "name text not null," +
                           "price integer default 0)";
                    // SQLs
                    db.execSQL(sql);
                    
                    // bZ[Wݒ
                    message = "e[u쐬܂I\n";
                    
                }catch(Exception e){
                	message  = "e[u͍쐬Ă܂I\n";
                	Log.e("ERROR",e.toString());
                }
                
                // f[^o^
                try{
                    
                    // gUNVJn
                    db.beginTransaction();
                    
                    // o^f[^ݒ
                    ContentValues val = new ContentValues();
                    val.put("productid", productid.getText().toString());
                    val.put("name", name.getText().toString());
                    val.put("price", price.getText().toString());
                    // f[^o^
                    db.insert("product", null, val);
                    
                    // R~bg
                    db.setTransactionSuccessful();
                    
                    // gUNVI
                    db.endTransaction();

                	// bZ[Wݒ
                    message += "f[^o^܂I";

                }catch(Exception e){
                	message  = "f[^o^Ɏs܂I";
                	Log.e("ERROR",e.toString());
                }
                
            // XV{^ꂽꍇ
    		}else if(tag.endsWith("update")){    			
                
    			// t@C̃f[^폜
    			try{
    				// XV
    				String condition = null;
    				if(productid != null && !productid.equals("")){
    					condition = "productid = '" + productid.getText().toString() + "'";
    				}
    				
                    // gUNVJn
                    db.beginTransaction();
                    
                    // XVf[^ݒ
                    ContentValues val = new ContentValues();
                    val.put("name", name.getText().toString());
                    val.put("price", price.getText().toString());
                    // f[^XV
                    db.update("product", val, condition, null);

                    // R~bg
                    db.setTransactionSuccessful();
                    
                    // gUNVI
                    db.endTransaction();
                    
                    // bZ[Wݒ
                    message = "f[^XV܂I";
                }catch(Exception e){
                    // bZ[Wݒ
                    message = "f[^XVɎs܂I";
                    Log.e("ERROR",e.toString());
                }  
    		
        	// 폜{^ꂽꍇ
    		}else if(tag.endsWith("delete")){   			
                
    			// t@C̃f[^폜
    			try{
    				// 폜
    				String condition = null;
    				if(productid != null && !productid.equals("")){
    					condition = "productid = '" + productid.getText().toString() + "'";
    				}
    				
                    // gUNVJn
                    db.beginTransaction();
                    
                    // f[^폜
                    db.delete("product", condition, null);

                    // R~bg
                    db.setTransactionSuccessful();
                    
                    // gUNVI
                    db.endTransaction();
                    
                    // bZ[Wݒ
                    message = "f[^폜܂I";
                }catch(Exception e){
                    // bZ[Wݒ
                    message = "f[^폜Ɏs܂I";
                    Log.e("ERROR",e.toString());
                }           
            
            // \{^ꂽꍇ
    		}else if(tag.equals("select")){
                
                // f[^擾
                try{
                	// YDBIuWFNg擾
                    db = helper.getReadableDatabase();
                
                    // 񖼒`
                    String columns[] = {"productid","name","price"};
                    
                    // f[^擾
                    Cursor cursor = db.query("product", columns, null, null, null, null, "productid");
                    
                    // e[uCAEg̕\͈͂ݒ
                    tablelayout.setStretchAllColumns(true);
                    
                    // e[uꗗ̃wb_ݒ
                    TableRow headrow = new TableRow(ContentProviderSample1Activity.this);
                    TextView headtxt1 = new TextView(ContentProviderSample1Activity.this);
                    headtxt1.setText("iID");
                    headtxt1.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt1.setWidth(60);
                    TextView headtxt2 = new TextView(ContentProviderSample1Activity.this);
                    headtxt2.setText("i");
                    headtxt2.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt2.setWidth(100);
                    TextView headtxt3 = new TextView(ContentProviderSample1Activity.this);
                    headtxt3.setText("i");
                    headtxt3.setGravity(Gravity.CENTER_HORIZONTAL);
                    headtxt3.setWidth(60);          
                    headrow.addView(headtxt1);
                    headrow.addView(headtxt2);
                    headrow.addView(headtxt3);
                    tablelayout.addView(headrow);
                    
                    // 擾f[^e[uוɐݒ
                    while(cursor.moveToNext()){                	
                        
                        TableRow row = new TableRow(ContentProviderSample1Activity.this);
                        TextView productidtxt = new TextView(ContentProviderSample1Activity.this);
                        productidtxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        productidtxt.setText(cursor.getString(0));
                        TextView nametxt = new TextView(ContentProviderSample1Activity.this);
                        nametxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        nametxt.setText(cursor.getString(1));
                        TextView pricetxt = new TextView(ContentProviderSample1Activity.this);
                        pricetxt.setGravity(Gravity.CENTER_HORIZONTAL);
                        pricetxt.setText(cursor.getString(2));
                        row.addView(productidtxt);
                        row.addView(nametxt);
                        row.addView(pricetxt);
                        tablelayout.addView(row);
                        
                        // bZ[Wݒ
                        message = "f[^擾܂I";
                    }
             
                }catch(Exception e){
                	// bZ[Wݒ
                    message = "f[^擾Ɏs܂I";
                    Log.e("ERROR",e.toString());
                }      
    		}
    		
            // DBIuWFNgN[Y
            db.close(); 
            
            // bZ[W\  
            label.setText(message);
    	}
    }
}